## Program to parse the GFF file downloaded from RFAM and count how many of each family we were able to find.
import sys
import re
from collections import defaultdict

def StartAnalysis():
	detectedNCRNA = defaultdict(tuple)
	ncRNAPosition = defaultdict(list)
	hasBeenFound = defaultdict(list)
	if len(sys.argv) < 3:
		print("Please specify a GFF to analyze and the result file.")
		return
		
	inputGFF = open(sys.argv[1], 'r')
	inputPOS = open(sys.argv[2], 'r')
	
	allGFF = inputGFF.read()
	pat = re.compile('CP.*\sRfam\sncRNA.*\s')
	m = pat.findall(allGFF)
	
	for line in m:
		preLine = line.split("\t")
		aLine = preLine[8]
		alias = aLine.split(";")[2].split("=")[1]
		
		if detectedNCRNA[alias] == ():
			detectedNCRNA[alias] = (0,0)
				
		ncRNAPosition[alias].append((preLine[3], preLine[4]))	
		hasBeenFound[alias].append(0)
		detectedNCRNA[alias] = (detectedNCRNA[alias][0]+1, detectedNCRNA[alias][1])
	
	## iterate through rna and detect if there exists an overlap
	allRNA = inputPOS.read()
	allRNA = allRNA.split("\n")
	totalrna = 0
	for pos in allRNA:
		if pos == '':
			break
		totalrna = 0
		pos = pos.split("\t")
		x = pos[0]
		y = pos[1]
		for rnakey in detectedNCRNA.keys():
			count = 0
			for rna in ncRNAPosition[rnakey]:
				nX = rna[0]
				nY = rna[1]
				totalrna += 1
				if hasBeenFound[rnakey][count] == 0:
					if ((x <= nX and y >= nY) or (x >= nX and x <= nY) or (y >= nX and y <= nY)):
						detectedNCRNA[rnakey] = (detectedNCRNA[rnakey][0], int(detectedNCRNA[rnakey][1])+1)
						hasBeenFound[rnakey][count] = 1
					
				count += 1
				
	for key in detectedNCRNA.keys():
		print key + "\t" + str(detectedNCRNA[key][0]) + "\t" + str(detectedNCRNA[key][1])
	
	inputGFF.close()
	inputPOS.close()

	

if __name__ == '__main__':
	StartAnalysis()
