## Shuffle a genome - maintain known NCRNA sequences.
import sys
import random

if len(sys.argv) < 3:
	print("python GenomeShuffler.py {GENOME} {RNAPOS}. Outputs: RandGenome.txt RandGenome.rnapos")
	sys.exit(0)

ranPos = []
genome = open(sys.argv[1], 'r').read()
rnapos = open(sys.argv[2], 'r').read()
rnaPositions = sorted([(x.split("\t") if x != '' else 'BLANK') for x in rnapos.split("\n")])
rnaText = [genome[int(pos[0])-1:int(pos[1])] if pos != 'BLANK' else "" for pos in rnaPositions]

randGenome = open("RandGenome.txt", 'w')
randRNAPOS = open("RandGenome.rnapos", 'w')

print(len(genome))
offset = 0
## Create positions for the RNA to be inserted into
for i in range(0, len(rnaPositions)):
	potential = random.randint(0, len(genome)-1)
	while potential in ranPos:
		potential = random.randint(0, len(genome)-1)
	ranPos.append(potential)
ranPos = sorted(ranPos)

## Remove known ncRNA from genome.
sub = 0
for pos in rnaText:
	if pos != "":
		sub += len(pos)
		genome = genome.replace(pos, "")
		
offset = 0
count = 0
cutLen = len(genome) ## length of genome after ncRNA are removed
## Shuffle whatever remains in the genome.
genome = list(genome)
while count < 300000:
	count += 1
	pos1 = random.randint(0, cutLen-1)
	pos2 = random.randint(0, cutLen-1)
	temp = genome[pos1] 
	genome[pos1] = genome[pos2]
	genome[pos2] = temp
	

## shuffle around the known NCRNA's
count = 0
while count < 100:
	count += 1
	pos1 = random.randint(0, len(rnaText)-1)
	pos2 = random.randint(0, len(rnaText)-1)
	temp = rnaText[pos1] 
	rnaText[pos1] = rnaText[pos2]
	rnaText[pos2] = temp
	
## Insert rna's back in
genome = "".join(genome)
count = 0
randRnaPositions = []
add = 0
for text in rnaText:
	if text != '':
		genome = genome[:ranPos[count]+offset] + text + genome[ranPos[count]+offset:]
		randRnaPositions.append((ranPos[count]+offset, ranPos[count]+offset+len(text)))
		offset += len(text)
		count+=1
		add += len(text)

print(len(genome))

for i in genome:
	randGenome.write(i)
for pos in randRnaPositions:
	randRNAPOS.write(str(pos[0]) + "\t" +str(pos[1]) + "\n")
	